use crate::{Connection, EventType};

#[test]
#[ignore = "broken, skipping"]
fn connect() {
    Connection::new().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn run_command_nothing() {
    let mut connection = Connection::new().unwrap();
    let result = connection.run_command("").unwrap();
    assert!(result.is_empty());
}

#[test]
#[ignore = "broken, skipping"]
fn run_command_single_success() {
    let mut connection = Connection::new().unwrap();
    let result = connection.run_command("exec /bin/true").unwrap();
    assert_eq!(result.len(), 1);
    result[0].as_ref().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn run_command_multiple_success() {
    let mut connection = Connection::new().unwrap();
    let result = connection
        .run_command("exec /bin/true; exec /bin/true")
        .unwrap();
    assert_eq!(result.len(), 2);
    result[0].as_ref().unwrap();
    result[1].as_ref().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn run_command_fail() {
    let mut connection = Connection::new().unwrap();
    let result = connection.run_command("somerandomcommand").unwrap();
    assert_eq!(result.len(), 1);
    assert!(result[0].as_ref().is_err());
}

#[test]
#[ignore = "broken, skipping"]
fn get_workspaces() {
    Connection::new().unwrap().get_workspaces().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn get_outputs() {
    Connection::new().unwrap().get_outputs().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn get_tree() {
    Connection::new().unwrap().get_tree().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn get_marks() {
    Connection::new().unwrap().get_marks().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn get_bar_ids() {
    Connection::new().unwrap().get_bar_ids().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn get_bar_ids_and_one_config() {
    let mut connection = Connection::new().unwrap();
    let ids = connection.get_bar_ids().unwrap();
    connection.get_bar_config(&ids[0]).unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn get_version() {
    Connection::new().unwrap().get_version().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn get_binding_modes() {
    Connection::new().unwrap().get_binding_modes().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn get_config() {
    Connection::new().unwrap().get_config().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn send_tick() {
    let success = Connection::new().unwrap().send_tick("").unwrap();
    assert!(success);
}

#[test]
#[ignore = "broken, skipping"]
fn sync() {
    let success = Connection::new().unwrap().sync().unwrap();
    assert!(!success, "sync should always return false on sway");
}

#[test]
#[ignore = "broken, skipping"]
fn get_binding_state() {
    Connection::new().unwrap().get_binding_state().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn get_inputs() {
    Connection::new().unwrap().get_inputs().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn get_seats() {
    Connection::new().unwrap().get_seats().unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn event_subscribe_all() {
    Connection::new()
        .unwrap()
        .subscribe(&[
            EventType::Workspace,
            EventType::Mode,
            EventType::Window,
            EventType::BarConfigUpdate,
            EventType::Binding,
            EventType::Shutdown,
            EventType::Tick,
            EventType::BarStateUpdate,
            EventType::Input,
        ])
        .unwrap();
}

#[test]
#[ignore = "broken, skipping"]
fn find_in_tree() {
    assert!(Connection::new()
        .unwrap()
        .get_tree()
        .unwrap()
        .find_as_ref(|n| n.focused)
        .is_some());
}

#[test]
#[ignore = "broken, skipping"]
fn find_in_tree_comp() {
    assert_eq!(
        Connection::new()
            .unwrap()
            .get_tree()
            .unwrap()
            .find_as_ref(|n| n.focused),
        Connection::new()
            .unwrap()
            .get_tree()
            .unwrap()
            .find(|n| n.focused)
            .as_ref()
    );
}

#[test]
#[ignore = "broken, skipping"]
fn find_focused_as_ref() {
    assert!(Connection::new()
        .unwrap()
        .get_tree()
        .unwrap()
        .find_focused_as_ref(|n| n.focused)
        .is_some());
}

#[test]
#[ignore = "broken, skipping"]
fn find_focused() {
    assert!(Connection::new()
        .unwrap()
        .get_tree()
        .unwrap()
        .find_focused(|n| n.focused)
        .is_some());
}

#[test]
#[ignore = "broken, skipping"]
fn find_in_tree_comp_find_focused() {
    assert_eq!(
        Connection::new()
            .unwrap()
            .get_tree()
            .unwrap()
            .find_focused(|n| n.focused),
        Connection::new()
            .unwrap()
            .get_tree()
            .unwrap()
            .find(|n| n.focused)
    );
}
